#ifndef H_SHELLCOMFUNCTIONS_20090317_1809
#define H_SHELLCOMFUNCTIONS_20090317_1809

#ifndef _WINDOWS_
#error Windows.h must be included before this file
#endif
#include <shlobj.h>

#ifndef EXTERN_C
#ifdef __cplusplus
#define EXTERN_C extern "C"
#else
#define EXTERN_C extern
#endif
#endif

//Return S_OK to continue enum, S_FALSE to stop, and error code to err.
typedef HRESULT (CALLBACK * SHLWNDENUMPROC)(INT_PTR userData, IDispatch *pDispShellWindow);
//Return TRUE on match.
typedef BOOL (CALLBACK * SHLWNDFINDPROC)(INT_PTR userData, IDispatch *pDispShellWindow);

EXTERN_C HRESULT IShellWindows_Item_int(IShellWindows *This, INT32 index, IDispatch **ppDispFolder);
EXTERN_C HRESULT EnumShellWindows(INT_PTR userData, SHLWNDENUMPROC enumProc);
EXTERN_C HRESULT FindShellWindow(INT_PTR userData, SHLWNDFINDPROC enumProc, IDispatch **ppDispShellWindow);
EXTERN_C HRESULT FindShellWindowByHandle(HWND hWndToFind, IDispatch **ppDispShellWindow);
EXTERN_C HRESULT FindShellWindowByPIDL(PCIDLIST_ABSOLUTE pidlToFind, IDispatch **ppDispShellWindow);
EXTERN_C HRESULT GetShellWindowFolderView(IDispatch *pDispShellWindow, REFIID riid, void **ppView, LPCTSTR *pErr);
EXTERN_C HRESULT GetFolderViewDirectoryPath(
 IFolderView *pView, /*[in]*/
 LPTSTR szPath,      /*[out] Must be at least MAX_PATH characters long.*/
 LPCTSTR *pErr       /*[out/opt] If non-NULL, may contain a static string pointer on error.*/
 );
EXTERN_C HRESULT GetFolderViewDisplayName(
 IFolderView *pView,      /*[in]*/
 SHGDNF displayNameFlags, /*[in]*/
 LPTSTR szName,           /*[out]*/
 UINT cchName,            /*[in] Size of szName in TCHARs.*/
 LPCTSTR *pErr            /*[out/opt] If non-NULL, may contain a static string pointer on error.*/
 );
EXTERN_C HRESULT GetFolderViewMoniker(IFolderView *pView, LPTSTR szPath, LPCTSTR *pErr);
EXTERN_C HRESULT GetFolderViewFocusedItemDisplayName(IFolderView *pView, SHGDNF displayNameFlags, LPTSTR szName, UINT cchName);

#endif/* ! H_SHELLCOMFUNCTIONS_20090317_1809 */
